#include <stdio.h>
#include <time.h>
#include <malloc.h>
#include <math.h>
#include "Multiply.h"

//routine to initialize an array with data

void init_matrix(int row, int col, FTYPE off, FTYPE  a[][COLWIDTH])
{
	int i,j;

	for (i=0; i< row;i++) {
		for (j=0; j< col;j++) {
			a[i][j] = fmod(i*j+off,10.0);
		}
	}
	if (COLBUF>0)
		for  (i=0;i<row;i++)
			for (j=col;j<COLWIDTH;j++)
				a[i][j]=0.0;
}

void init_array(int length, FTYPE off, FTYPE a[])
{
	int i;

	for (i=0; i< length;i++)
		a[i] = fmod(i+off,10.0);
	if (COLBUF>0)
		for  (i=length;i<COLWIDTH;i++)
				a[i]=0.0;
}

void printsum(int length, FTYPE ans[]) {
	// Doesn't print the whole matrix - Just a very simple Checksum
	int i;
	double sum=0.0;

	for (i=0;i<length;i++) sum+=ans[i];

	printf("Sum of result = %f\n", sum); 
}

main()
{
	clock_t start, stop;
	int i;

        FTYPE a[ROW][COLWIDTH];
        FTYPE b[ROW];
        FTYPE x[COLWIDTH];

	size1 = ROW;
	size2 = COLWIDTH;
	inc_i = 1;
	inc_j=1;

        printf("ROW:%d COL: %d\n",ROW,COL);

    // initialize the arrays with data
	init_matrix(ROW,COL,1,a);
	init_array(COL,3,x);

	//start timing the matrix multiply code
	start = clock();
	for (i = 0;i < REPEATNTIMES;i++)
		matvec(a,b,x);
	stop = clock();

        // print elapsed time
	printf("Elapsed time = %lf seconds\n",
    		((double)(stop - start)) / CLOCKS_PER_SEC);

	printf("GigaFlops = %f\n", (((double)REPEATNTIMES * (double)COL * (double)ROW * 2.0) / (((double)(stop - start)) / CLOCKS_PER_SEC))/1000000000.0);
	
	printsum(COL,b);
}

