#define NP 4

#include <stdio.h>
#include <time.h>
#include "square.h"

int main() {



/*    program to calculate electrostatic potential at a series of
      points (xp,yp)  due to a uniform charge distribution over the
      square with corners (x0,y0) and (xn,yn)  */

 const float x0=-1., xn=1., y0=-1., yn=1. ;

 const int nx=10000, ny=10000 ;
 clock_t start, stop;
 float  potential[NP];
 float xp[NP] = {-2., 0.5, 6.0, 1.01};
 float yp[NP] = {2., -3., 8., 0.5};
 int ip;

 start = clock();
//  #pragma omp parallel for
 for (ip=0;ip<NP;ip++)  {
     potential[ip] = twod_int(x0,xn,y0,yn,nx,ny,xp[ip],yp[ip]);
 }
 stop = clock();

 printf ("potentials %f, %f, %f, %f \n",
          potential[0],potential[1],potential[2],potential[3]);

 // print elapsed time
 printf("Elapsed time = %lf seconds\n",
  		((double)(stop - start)) / CLOCKS_PER_SEC);
}

