      program square_charge
      
!     program to calculate electrostatic potential at a series of 
!     points (xp,yp)  due to a uniform charge distribution over the
!     square with corners (x0,y0) and (xn,yn)

      parameter (x0=-1.,xn=1.,y0=-1.,yn=1.)
      parameter (np=4)
      parameter (nx=10000, ny=10000)
      
      real points(2,np), potential(np)
      real(8) t1,t2 
      
      data points / -2.,2., 0.5, -3., 6.0,8.0, 1.00001,0.5 /
      
      call cpu_time(t1)


!$OMP PARALLEL DO PRIVATE (xp, yp)   
      do ip = 1,np
         xp = points(1,ip)
         yp = points(2,ip)
         potential(ip) = twod_int(x0,xn,y0,yn,nx,ny,xp,yp)
         
      enddo
      
      call cpu_time(t2)

      
      print *, 'potentials ',(potential(i), i=1,np),np
      print *, 'time       ',t2-t1
      
      end